#!/usr/bin/perl

# PACKAGES
use LWP::UserAgent;
use JSON;

print "Content-type:text/html\r\n\r\n";
print '<html>';
print '<head>';
print '<title>Hello Word - First CGI Program</title>';
print '</head>';
print '<body>';


###############################
## POST method processing #####
###############################

local ($buffer, @pairs, $pair, $name, $value, %FORM);
# Read in text
$ENV{'REQUEST_METHOD'} =~ tr/a-z/A-Z/;
if ($ENV{'REQUEST_METHOD'} eq "POST") 
{
       read(STDIN, $buffer, $ENV{'CONTENT_LENGTH'});
     }else {
       $buffer = $ENV{'QUERY_STRING'};
} 
  
# Split information into name/value pairs to change it to a nice perl hash perl variable %FORM
@pairs = split(/&/, $buffer);
foreach $pair (@pairs)
{
   ($name, $value) = split(/=/, $pair);
   $value =~ tr/+/ /;
   $value =~ s/%(..)/pack("C", hex($1))/eg;
   $FORM{$name} = $value;
}
 
@keys = keys %FORM;
$form_size = @keys;

# now show/do something if something arrived from the formular

if ($form_size > 0)
{
        if ( exists ($FORM{'username'}) && exists ($FORM{'controller_ip'}) && exists ($FORM{'password'}) && exists ($FORM{'token'}) )
        {
		print "<h4>Authentication token recieved ... </h4>";
		goto FILE_FUNCTION;
	}
	else
	{
		print "<h3>You missed comming to this file with authentication data, go back to 01_auth.cgi</h3>";
		goto END;
	}
}
else
{
	print "<h3>You missed comming to this file with authentication data, go back to 01_auth.cgi</h3>";
	goto END;
}

##############################
## END POST PROCESSING #######
##############################


##############
# FUNCTIONS ##
##############
sub print_hash_in_table {   
        my (%hash) = @_;
        
	print '<table border=1>';
	foreach my $key ( keys %hash )
        {
               my $value = $hash{$key};  
               print "<tr><td>name=\"$key\"</td><td>value=\"$value\"</td></tr>";
        }
	print '</table><br>';
}


FILE_FUNCTION:
#	print "Real perl logic here:";
        $url = 'https://' . $FORM{'controller_ip'} . ':8443/sdn/v2.0/net/devices';        
        print "$url";
	my $ua = LWP::UserAgent->new( ssl_opts => { 
                                verify_hostname => 0,   
                                SSL_verify_mode => 'SSL_VERIFY_NONE'
                                } );            
        my $req = HTTP::Request->new(GET => $url);
        $req->header('content-type' => 'application/json');
        $req->header('x-auth-token' => $FORM{'token'});
        $response = $ua->request($req);
        my $devices;
        if ($response->is_success) {
                my $json = $response->decoded_content;
                $devices = from_json($json);
                print_hash_in_table(%$devices);
                $devices = $devices->{'devices'};             

			
		
        } else {
                print "<h1>fuck!</h1>";
		goto WRONG_OUTPUT;
        }
        
        my $key;
        my $device;
        my $uptime= uptime;
        while (($key, $device) = each $devices) {
                my $status;
		print "<br><br>=================================================<br>";
		print_hash_in_table(%$device);
 
                if($device->{'Device Status'} eq "Online"){
			
                        print "Device $device->{uid} is <font color=\"GREEN\">ONLINE</font><br>";
                        $url = 'https://' . $FORM{'controller_ip'} . ':8443/sdn/v2.0/net/devices/' . $device->{uid} . '/interfaces';
                        my $token = $FORM{'token'};
                        #print "$url<br>$token<br>";
                        my $req2 = HTTP::Request->new(GET => $url);
                        $req2->header('content-type' => 'application/json');
                        $req2->header('x-auth-token' => $FORM{'token'});
                        $response = $ua->request($req2);
			if ($response->is_success) {
                                my $json = $response->decoded_content;
                                $interfaces = from_json($json); 
				
				print_hash_in_table(%$ubterfaces); 

				$interfaces = $interfaces->{'Interfaces'};

                		while (($key2, $interface) = each $interfaces) {
                        		print_hash_in_table(%$interface);
                		}

				


				
                        }
                        else
                        {   
                                print "Unable to get interfaces from $device->{uid}";
                        }                        
                              
                }
                else
                {
                        print "Device $device->{uid} is <font color=\"RED\">OFFLINE</font><br>";
                }
                

	}
	


goto END;	
WRONG_OUTPUT:
	print "<h5>something went wrong</h5>";


END:


print '</body>';
print '</html>';

1;